import twitter4j.*;
import twitter4j.auth.*;
import java.io.*;
import java.util.*;

public class TwitterWrapper
{
  AccessToken accessToken;
  
  public TwitterWrapper(String publicKey, String privateKey)
  {
    try
    {
      // Get twitter object
      Twitter twitter = TwitterFactory.getSingleton();
      
      // Do OAuth which will authenticate the user
      twitter.setOAuthConsumer(publicKey, privateKey);
      RequestToken requestToken = twitter.getOAuthRequestToken();
      AccessToken accessToken = null;
      BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
      while (null == accessToken) {
        System.out.println("Open the following URL and grant access to your account:");
        System.out.println(requestToken.getAuthorizationURL());
        System.out.print("Enter the PIN(if aviailable) or just hit enter.[PIN]:");
        String pin = br.readLine();
        try{
          if(pin.length() > 0){
            accessToken = twitter.getOAuthAccessToken(requestToken, pin);
          }else{
            accessToken = twitter.getOAuthAccessToken();
          }
        } catch (TwitterException te) {
          if(401 == te.getStatusCode()){
            System.out.println("Unable to get the access token.");
          }else{
            te.printStackTrace();
          }
        }
      }
      
      //store twitter object and access token
      setAccessToken(accessToken);
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  
  private void setAccessToken(AccessToken accessToken){
    this.accessToken = accessToken;
  }
  
  private AccessToken getAccessToken()
  {
    return this.accessToken;
  }
  
  public void setStatus(String s)
  {
    try
    {
      Twitter twitter = TwitterFactory.getSingleton();
      Status status = twitter.updateStatus(s);
      System.out.println("Successfully updated the status to [" + status.getText() + "].");
    } 
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  
  public String[] getTweets()
  {
    try
    {
      Twitter twitter = TwitterFactory.getSingleton();
      List<Status> statuses = twitter.getHomeTimeline();
      String[] result = new String[statuses.size()];
      
      int pos = 0;
      for (Status status : statuses) {
        result[pos] = status.getUser().getName() + ":" + status.getText();
        pos++;
      }
      
      return result;
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
    
    return null;
  }
}